require 'tk'
#___________ Run Script ______________
class BMI
def self.run
`ruby "BMI_calc.rb"`
end

end
#################### Main Window ########################
root = TkRoot.new{title "BMI Calculator"}
###################  Variables ########################
$w =TkVariable.new
$h =TkVariable.new
$bmi =TkVariable.new
$j =TkVariable.new
#____________________ BUTTON ______________________________________
button = TkButton.new(root) {
  text 'Calculate BMI'
  command(proc{bmi($w, $h); judgement($bmi)})
  background "white"
  borderwidth 4
  font TkFont.new('times 14 bold')
  foreground  "black"
  'padx' '10'
  'pady' '15'
  relief 'raised'
}

#__________________________ METHODS _______________________________
def bmi(w, h)
h = (h.to_f)/100
w = (w.to_f)/100
$bmi.value= (w/(h**2)).round(2)
end

def judgement(bmi)
if bmi < 0.18
    judgment = "You are underweight"
elsif bmi >= 0.18 && bmi < 0.25
    judgment = "You have normal Weight" 
elsif bmi > 0.25
   judgment = "You are over-weight"
end

$j.value = "#{judgment}"

end

###################### LABELS ##########################
w = TkLabel.new(root) do
  text "Weight in Kg"
  background "green"
  borderwidth 4
  font TkFont.new('times 14 bold')
  foreground  "black"
  'padx' '10'
  'pady' '15'
  relief 'raised'
  end

h = TkLabel.new(root) do
  text "Height in cm"
  background "green"
  borderwidth 4
  font TkFont.new('times 14 bold')
  foreground  "black"
  'padx' '10'
  'pady' '15'
  relief 'raised'
  end

g = TkLabel.new(root) do
  text "BMI"
  background "Orange"
  borderwidth 4
  font TkFont.new('times 14 bold')
  foreground  "black"
  'padx' '10'
  'pady' '15'
  relief 'raised'
  end


################### Entry Fields #######################
w_entry = TkEntry.new(root){
text " "
background "yellow"
borderwidth 4
font TkFont.new('times 14 bold')
foreground  "black"
relief 'groove'
textvariable $w
}

h_entry = TkEntry.new(root){
text " "
background "yellow"
borderwidth 4
font TkFont.new('times 14 bold')
foreground  "black"
relief 'groove'
textvariable $h
}
#______________________________ TEXT ___________________________________
g_label  = TkLabel.new(root){
background "yellow"
borderwidth 4
font TkFont.new('tahoma 12 bold')
foreground  "black"
relief 'groove'
textvariable  $bmi
width 10
height 1
}

judgement  = TkLabel.new(root){
background "yellow"
borderwidth 4
font TkFont.new('tahoma 12 bold')
foreground  "black"
relief 'groove'
textvariable  $j
wraplength 200
width 15
height 3
}

##################### Geometry ##################################
# Labels
w.grid('row' => 0, 'column' => 0, 'sticky' => 'we')
h.grid('row' => 1, 'column' => 0, 'sticky' => 'we')
g.grid('row' => 2, 'column' => 0, 'sticky' => 'we')

#button
button.grid('row' => 3, 'column' => 0, 'sticky' => 'we')

#entries
w_entry.grid('row' => 0, 'column' => 1, 'sticky' => 'we')
h_entry.grid('row' => 1, 'column' => 1, 'sticky' => 'we')
g_label.grid('row' => 2, 'column' => 1, 'sticky' => 'we')
judgement.grid('row' => 3, 'column' => 1, 'sticky' => 'we')

#_______________________________________ Show __________________________________
Tk.mainloop

##############################################################
